<?php
/*
Plugin Name: Tw Leech Pro
Plugin URI: http://thucdem.mobi
Description: Plugin leech truyện
Version: 1.0
Author: MrTaiw
Author URI: http://thucdem.mobi
*/
set_time_limit(300);
define('TW_PATH', plugin_dir_path(__FILE__));
add_action('admin_menu', 'TW_admin_actions');
add_action('wp_ajax_tw_leech_pro', 'tw_leech_ajax');
function TW_admin_actions(){ 
    $icon_url = plugins_url('/assets/images/favicon.png', __FILE__);
    add_menu_page( __( 'Tw Leech Pro', 'TW_leech_ui' ), __( 'Tw Leech Pro', 'Tw Leech' ), 'update_core', 'tw-leech-pro', 'TW_leech_ui', $icon_url );
}

function TW_leech_ui(){
	
	$tool_name = empty($_GET['tool']) ? 'error' : $_GET['tool'];
	tw_leech_style();
	$tool_path = TW_PATH . 'tools/' . $tool_name;
	if(file_exists($tool_path)){
		require_once($tool_path);
		tool_index();
	}
	else
		tw_leech_ui_index();
}


function tw_leech_ui_index(){
	
	if(isset($_POST['upload']))
			tw_leech_upload();
		$list = scan_tools();
		echo '<div class="tw_main">';
		echo '<h2>TW LEECH PRO</h2><table class="wp-list-table widefat"><thead><td>Tool Name</td><td>Author</td><td>More info</td></thead>';
		foreach($list as $tool){
			$info = tw_get_info_tool($tool);
			echo '<tr><td><a href="?page=tw-leech-pro&tool='.$tool.'">'.$info['Tool_Name'].'</a></td><td><a target="_blank" href="http://'.$info['Tool_url'].'">'.$info['Author'].'</a></td><td>'.$info['Contact'].'</td></tr>';
		}
		echo '</table>';
		echo '<form enctype="multipart/form-data" method="post">
		<input type="file" name="tool"/>
		<input type="submit" name="upload" value="Upload"/>
		</form></div>';
}

function scan_tools(){

    $dir  = TW_PATH.'tools';
    $list = scandir($dir);
    foreach($list as $tool){
    	if($tool != '.' && $tool != '..'){
    		$tools[] = $tool;
    	}
    }
    return $tools;
}


function tw_leech_ajax() {
    
    include(TW_PATH . 'tools/' . $_POST['tool']);
    $_POST['callback']();
    die();
}

function tw_get_info_tool($name){

	$path    = TW_PATH . 'tools/'.$name;
	$content = file_get_contents($path);
	preg_match("/\/*tool info\s(.*)\s*\//is", $content, $info);
	if($info){
		$get_info = explode("\n", $info[1]);
		$get_info = str_replace('@', '', $get_info);
		foreach($get_info as $i){
			$ex = explode(' : ', $i);
			if('' != $ex[0])
				$return[$ex[0]] = $ex[1];
		}
	}
	return $return;
}

function tw_leech_upload(){

		if($_FILES['tool']){
			$name = explode('.', $_FILES['tool']['name']);
			if($name[1] != 'php' || substr($name[0], 0, 3) != 'tw_'){
				_e('Lỗi upload.','spnoy');
			}
			else
			{
			    $path = TW_PATH . 'tools/' . $_FILES['tool']['name'];
			    if(move_uploaded_file($_FILES['tool']['tmp_name'], $path))
			    	_e('upload thành công.','spnoy');
			    else
			    	_e('Lỗi upload.','spnoy');
		    }
		}
}


function tw_leech_thumbnail($post_id, $url){
	
	$upload_dir = wp_upload_dir();
	$image_data = file_get_contents($url);
	$filename   = basename($url);
	if(wp_mkdir_p($upload_dir['path']))
		$file = $upload_dir['path'] . '/' . $filename;
	else
		$file = $upload_dir['basedir'] . '/' . $filename;
	file_put_contents($file, $image_data);
	$wp_filetype = wp_check_filetype($filename, null );
	$attachment  = array(
		'post_mime_type' => $wp_filetype['type'],
		'post_title'     => sanitize_file_name($filename),
		'post_content'   => '',
		'post_status'    => 'inherit'
		);
	$attach_id = wp_insert_attachment( $attachment, $file, $post_id );
	require_once(ABSPATH . 'wp-admin/includes/image.php');
	$attach_data = wp_generate_attachment_metadata( $attach_id, $file );
	wp_update_attachment_metadata( $attach_id, $attach_data );
	set_post_thumbnail( $post_id, $attach_id );
}


function tw_leech_insert_data($category, $title, $content, $post_type, $slug = false, $post_parent = false, $post_status = 'publish'){
	
	$data = array(
	  'post_title'    => $title,
	  'post_content'  => $content,
	  'post_status'   => $post_status,
	  'post_author'   => 1,
	  'post_category' => array($category),
	  'post_type'     => $post_type
	);
	if($slug){
		$data['post_name'] = $slug;
	}
	if($post_parent){
		$data['post_parent'] = $post_parent;
	}
	$id = wp_insert_post($data);
	return $id;
}


function tw_leech_style(){
?>
    <style>
    .tw_progress{
    	background-image: linear-gradient(to bottom, #EBEBEB 0px, #F5F5F5 100%);
    	background-repeat: repeat-x;
    	width: 100%;
    	height: 20px;
    	position: relative;
    	border-radius: 6px;
    }
    #tw_progress{
    	display: inline-block;
    	height: 20px;
    	background-image: linear-gradient(to bottom, #5CB85C 0px, #449D44 100%);
    	background-repeat: repeat-x;
    	position: absolute;
    	border-radius: 6px;
    }
    .tw_progress_only{
    	position: absolute;
    	text-align: center;
    	font-size: 10pt;
    	width: 100%;
    }
    .tw_main{
    	width: 100%;
    	max-width: 900px;
    	margin-right: 0px;
    	margin-left: 0px;
    	background-color: #FFF;
    	border-color: #DDD;
    	border-width: 1px;
    	border-radius: 4px 4px 0px 0px;
    	box-shadow: none;
    	padding: 4px;
    }
    </style>
<?php
}
?>